import {states, isJQL, _array, isElement} from "../../utils/lib.js";
import handleMove from "./move.js";

export default (_, { el, e, height, width, movable,  relativeTo: rt, onMove, onMoving, onMoved }) => {
    if(_array(e.path).includes(el)) return;
    el = _(el).addClass('mini-scrollbar');
    let x, y, _x, _y, to;

    height = height || 400;
    width = width || 250;
    el.style({
        height: height + 'px',
        width: width + 'px',
        zIndex: ++states.zIindex,
        left: 'unset',
        right: 'unset',
        bottom: 'unset',
        top: 'unset'
    });

    let path = e.path;
    to = isJQL(rt) ? rt.plain(0) : isElement(rt) ? rt : null;
    to = to && path.includes(to) ? to : null;

    if (!to) {
        to = _(document.body);
        el.style({ position: 'fixed' });
        x = e.x;
        y = e.y;
        _y = innerHeight - y;
        _x = innerWidth - x;

        el.style({ top: y + 'px' });
        if (_y < height)
            el.style({ top: (y - (height - _y) - 20) + 'px' });

        el.style({ left: x + 'px' });
        if (_x < width)
            el.style({ left: x - (width - _x) - 20 + 'px' });
    } else {
        to = _(to);
        let bc = to.getBoundingClientRect();

        let distY = (e.y + to.scrollTop() - bc.top);
        let distX = (e.x + to.scrollLeft() - bc.left);

        
        const lamda = to.hasAttribute('mounted') ? 2 : 1;
        if (distY + height*lamda > to.scrollHeight())
            distY = to.scrollHeight() - height*lamda - 10;

        if (distX + width > to.scrollWidth())
            distX = to.scrollWidth() - width - 5;

        to = to.style({ position: 'relative' });
        el.style({ position: 'absolute', top: distY + 'px' });
        el.style({ left: distX + 'px' });
        to.attr({mounted: 'true'});
    }
    el.appendTo(to);
    if (movable) {
        let movepoint = el;
        if (isJQL(movable))
            movepoint = movable;
        if (typeof movable === 'object' && movable.tagName)
            movepoint = _(movable);

        handleMove(_, { el: el.plain(), movepoint, onMove, onMoving, onMoved })
    }

    let transition = el.getStyle('transition');
    el.style({transform: 'scale(0)'});
    setTimeout(() => el.style({transition: '0.1s transform', transform: 'scale(1)'}), 1);
    setTimeout(() => el.style({transition}), 101);
    return el;
}